﻿using System;

namespace ConsoleApplication1
{
    public class Computer
    {
        bool powerOn;
        public void Boot() { }
        public void Shutdown() { }
        public void Reset() { }
    }

    public class Notebook : Computer
    {
        bool fingerScan;   // Notebook 타입에 해당하는 멤버만 추가
        public bool HasFingerScanDevice() { return fingerScan; }

        public void CloseLid()
        {
            Shutdown();    // Notebook에서 추가된 메소드 내에서 부모의 메소드 호출
        }
    }

    public class Desktop : Computer
    {
    }

    public class Netbook : Computer
    {
    }


    class Program
    {
        static void Main(string[] args)
        {
            // [코드 4 10: 부모 인스턴스를 자식으로 형변환 하는 경우]
            Notebook noteBook = new Notebook();

            Computer pc1 = noteBook;  // 암시적 형변환 가능
            pc1.Boot();
            pc1.Shutdown();

            Computer pc = new Computer();
            // Notebook notebook = (Notebook)pc;   // 명시적 형변환, 컴파일은 가능하지만 예외 발생

            Notebook note2 = (Notebook)pc1;  // 다시 본래 타입으로 명시적 형변환
            note2.CloseLid();

            // [코드 4 11: 배열 요소에서의 암시적 형변환]
            Computer[] machines = new Computer[]
                    { new Notebook(), new Desktop(), new Netbook() }; // 암시적 형변환

            DeviceManager manager = new DeviceManager();

            foreach (Computer device in machines)
            {
                manager.TurnOff(device);
            }
        }
    }

    public class DeviceManager
    {
        public void TurnOff(Computer device)
        {
            device.Shutdown();
        }
    }

}
